#include <DueTimer.h>
#include "RoboClaw.h"

#define address 0x80

int myLed = 13;
int count;
bool ledOn = false;
int speed_m2=10;
uint8_t status2;
bool valid2;
int32_t actual_encoder_position;
uint8_t S3mode;
uint8_t S4mode;
uint8_t S5mode;

RoboClaw roboclaw(&Serial1,10000);

void setup()
{
  Serial.begin(115200);
  roboclaw.begin(38400);
//  roboclaw.SetPinFunctions(address, 0, 1, 1);
//  roboclaw.GetPinFunctions(address, S3mode, S4mode, S5mode);
	pinMode(myLed, OUTPUT);
  int zero_speed=0;
  roboclaw.ForwardM2(address,zero_speed);
  delay(1000);
  roboclaw.ResetEncoders(address);
	Timer6.attachInterrupt(myHandler).setFrequency(5).start();
  Serial.print("Start!");
  Serial.println();
}

void loop()
{
  Serial.print("Counter: ");
  Serial.print(count, DEC);
  Serial.print("; Encoder: ");
  Serial.print(actual_encoder_position, DEC);
  Serial.println();
  delay(1000);
}


void myHandler()
{
  actual_encoder_position = roboclaw.ReadEncM2(address, &status2, &valid2);
  roboclaw.ForwardM2(address,speed_m2);  
  
  ledOn = !ledOn;
  digitalWrite(myLed, ledOn); 
}





